package utopp.gui;
	 
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;

public class ComponentFactory {


  public static JButton getJButton(String text, ActionListener listen)
  {
  	JButton h = new JButton(text);
	h.addActionListener(listen);
	return h;
  }
  
  public static JMenuItem getJMenuItem(String text, ActionListener listen){
    JMenuItem h = new JMenuItem(text);
	h.addActionListener(listen);
	return h;
  }

  public static String[] TYPEN = {"int","boolean","float","double","String"};
  public static String[] SICHTBARKEIT = {"default","private","protected","public"}; 
  public static String[] KARDINALITAET = {"*","1","1..*","0..*"};
  public static String[] STEREOTYP = {"Interface","Unterklasse","Abstrakte Klasse",
  	      						"Powertype","Akteur","Boundary","Controler","Entitt"};
  
  public static String[] ASSOZIATIONSTYP = {"Assoziation","Aggregation","Komposition",
               "Generalisierung","Realisierung","Abhngigkeit"};
		
  public static String[] RICHTUNG = {"1->2","2->1","ungerichtet"};	   
			   
  public static JComboBox getCombo(String[] items, boolean isEditable){
  	    
      JComboBox h = new JComboBox(items);
	  h.setEditable(isEditable);
	  return h;
  }
  
  public static JComboBox getTypCombo()
  { 
    return getCombo(TYPEN, true);  
  }
  
  public static JComboBox getSichtbarkeitCombo(){
    return getCombo(SICHTBARKEIT, false); 
  }
  
  public static JComboBox getKardinalitaetCombo(){
    return getCombo(KARDINALITAET, true);
  }
  
  public static JComboBox getStereotypCombo(){
    return getCombo(STEREOTYP, true);
  }
  
  public static JComboBox getAssoziationstypCombo()
  {
  	return getCombo(ASSOZIATIONSTYP, false);
  };
  
  public static JComboBox getRichtungCombo()
  {
  	return getCombo(RICHTUNG, false);
  };
  
  public static JTextArea getArea(){
    JTextArea h = new JTextArea(3,16);
	h.setLineWrap(true);
	return h;
  }
  
  public static JScrollPane getScrollPane(JComponent comp)
  {
    JScrollPane h = new JScrollPane(comp);
	h.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
	h.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
	return h;
  }
  
  public static JPopupMenu getListPopupMenu(ActionListener al){
  
    JPopupMenu h = new JPopupMenu();
    h.add(getJMenuItem("Neu", al));
	h.add(getJMenuItem("Lschen", al));
	return h;   
  }
  
}