package utopp.gui.klassenframe;

import java.awt.*;
import javax.swing.*;
import utopp.gui.*;
import utopp.modell.*;

public class ClassAllgPanel extends DataPanel
{
  JTextField jtfName;
  JComboBox jcobStereotyp;
  JTextField jtfPaket;
  JComboBox jcobSichtbarkeit;
  JTextArea jtaZusicherungen;
  JTextArea jtaEigenschaften;
		
  public ClassAllgPanel()
    	{
			super();
    		initGUI();
    	}
    	
  public void setData(Object data){
    UmlKlasse h = (UmlKlasse) data;
	
	jtfName.setText(h.getName());
	jcobStereotyp.setSelectedItem(h.getStereotyp());
	jcobSichtbarkeit.setSelectedItem(h.getSichtbarkeit());
	jtfPaket.setText(h.getPaket());
	jtaZusicherungen.setText(h.getZusicherung());
	jtaEigenschaften.setText(h.getEigenschaften());
	showing = data;
  };
  
  public void getData(Object item){
  	UmlKlasse h  = (UmlKlasse) item;
  	h.setName(jtfName.getText());
	h.setStereotyp((String) jcobStereotyp.getSelectedItem());
	h.setSichtbarkeit((String) jcobSichtbarkeit.getSelectedItem());
	h.setPaket(jtfPaket.getText());
	h.setZusicherung(jtaZusicherungen.getText());
	h.setEigenschaften(jtaEigenschaften.getText()); 
  };
  
  
  public Object getObject(){
  	return (Object) new UmlKlasse(jtfName.getText(),
								  (String) jcobStereotyp.getSelectedItem(),
								  (String) jcobSichtbarkeit.getSelectedItem(),
								  jtfPaket.getText(),
								  jtaZusicherungen.getText(),
								  jtaEigenschaften.getText()); 
  };
  
  public Object getDummy(){
  	return (Object) new UmlKlasse("<name>","","default","","",""); 
  }; 
	    
	  void initGUI()
  		{  
		
	    GridBagConstraints myGBC = new GridBagConstraints();
	    myGBC.fill = GridBagConstraints.BOTH;
		
		myGBC.insets = NORMAL;
		
		add(new JLabel("Name"), myGBC, 0, 0, 1, 1, 100, 0);		  
	    jtfName = new JTextField();
            jtfName.addActionListener(this);
	    add(jtfName, myGBC, 0,1, 1, 1, 100, 0);
		  
	    add(new JLabel("Stereotyp"), myGBC, 2, 0, 1, 1, 100, 0);		  
	    jcobStereotyp = ComponentFactory.getStereotypCombo();
	    add(jcobStereotyp, myGBC, 2, 1, 1, 1, 100, 0);
		  
	    add( new JLabel("Paket"), myGBC, 0, 2, 1, 1, 100, 0);		  
	    jtfPaket = new JTextField();
	    add(jtfPaket, myGBC, 0, 3, 1, 1, 100, 0);
		  
	    add(new JLabel("Sichtbarkeit"), myGBC, 2, 2, 1, 1, 100, 0);		  
	    jcobSichtbarkeit = ComponentFactory.getSichtbarkeitCombo();
	    add(jcobSichtbarkeit, myGBC, 2, 3, 1, 1, 100, 0);
		  
		myGBC.insets = OBEN;
	    add(new JLabel("Zusicherungen"), myGBC, 0, 4, 1, 1, 100, 0);		  
	    add(new JLabel("Eigenschaften"), myGBC, 2, 4, 1, 1, 100, 0);
		  
		myGBC.insets = NORMAL;
		jtaZusicherungen = new JTextArea(6, 20);
	    add(new JScrollPane(jtaZusicherungen), myGBC, 0, 5, 2, 1, 100, 100);
		  
	    jtaEigenschaften = new JTextArea(6, 20);
	    add(new JScrollPane(jtaEigenschaften), myGBC, 2, 5, 2, 1, 100, 100); 
  	}
  }    
      
      
      
      
      
      	
    	