package utopp.gui.klassenframe;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import utopp.gui.*;
import utopp.modell.*;

public class MethodenDataPanel extends DataPanel
{  
   JTextField jtfName;
   JComboBox jcobSichtbarkeit;
   JComboBox jcobRueckgabetyp;
   JTextArea jtaZusicherung;
   JTextArea jtaEigenschaften; 
   UmlParameterListe vParam = new UmlParameterListe();
   
   ParameterDialog pdParameter;
				
  public MethodenDataPanel(JFrame parent)
  {
    super();
	pdParameter = new ParameterDialog(parent);
	
	initGUI();		 
  }
  
  
  public void setData(Object data)
  {
  	 UmlMethode h = (UmlMethode) data;
     this.jtfName.setText(h.getName());
	 this.jcobSichtbarkeit.setSelectedItem(h.getSichtbarkeit()); 
	 this.jcobRueckgabetyp.setSelectedItem(h.getRueckgabetyp()); 
	 this.jtaZusicherung.setText(h.getZusicherung());
	 this.jtaEigenschaften.setText(h.getEigenschaften());
	 vParam = h.getParameter();
	 showing = data;	
  }
  
  public void getData(Object item){
  	UmlMethode h = (UmlMethode) item;
	h.setName(jtfName.getText());
	h.setRueckgabetyp((String) jcobRueckgabetyp.getSelectedItem()); 
	h.setSichtbarkeit((String) jcobSichtbarkeit.getSelectedItem()); 
	h.setZusicherung(jtaZusicherung.getText()); 
	h.setEigenschaften(jtaEigenschaften.getText());					 
    h.setParameter(vParam);	   
  }
   
  public Object getObject(){
  	UmlMethode h = new UmlMethode(jtfName.getText(),			     
					(String) jcobRueckgabetyp.getSelectedItem(), 
					(String) jcobSichtbarkeit.getSelectedItem(), 
					 jtaZusicherung.getText(), 
					 jtaEigenschaften.getText());
 					 
    h.setParameter(vParam);
	 
	return (Object) h;   
  }
  
  public Object getDummy(){
    return (Object) new UmlMethode("<name>","int","default","","");
  }
  	
  public void actionPerformed(ActionEvent e){
    if (e.getActionCommand().equals("Parameter..."))
	  if (pdParameter.showDialog(this.vParam)) 
	    this.vParam = pdParameter.getData();
	
    super.actionPerformed(e); 	  
  }	
   	
  void initGUI()
    {
      //Einstellung des Layouts
    GridBagConstraints myGBC = new GridBagConstraints();
    myGBC.fill = GridBagConstraints.BOTH;
	
	myGBC.insets = NORMAL;
	    
      add(new JLabel("Name"), myGBC,0,0,1,1,100,0);
      jtfName = new JTextField();
	  jtfName.addActionListener(this);
      add(jtfName, myGBC,1,0,1,1,100,0);
	  
      add(new JLabel("Sichtbarkeit"), myGBC,0,1,1,1,100,0);
      jcobSichtbarkeit = ComponentFactory.getSichtbarkeitCombo();	  
	  jcobSichtbarkeit.addActionListener(this);
      add(jcobSichtbarkeit, myGBC,1,1,1,1,100,0);
	  
      add(new JLabel("Rckgabetyp"), myGBC,0,2,1,1,100,0);
      jcobRueckgabetyp = ComponentFactory.getTypCombo();	  
	  jcobRueckgabetyp.addActionListener(this);
      add(jcobRueckgabetyp, myGBC,1,2,1,1,100,0);
	  
      add(new JLabel("Zusicherungen"), myGBC,0,3,1,1,100,0);
      jtaZusicherung = ComponentFactory.getArea();
      add(ComponentFactory.getScrollPane(jtaZusicherung), myGBC,1,3,1,2,100,100);

      add(new JLabel("Eigenschaften"), myGBC,0,5,1,1,100,0);
      jtaEigenschaften = ComponentFactory.getArea();
      add(ComponentFactory.getScrollPane(jtaEigenschaften), myGBC,1,5,1,2,100,100);
	  
	  
 	  myGBC.insets = OBEN;
      add(ComponentFactory.getJButton("Parameter...",this), myGBC,1,8,1,1,100,0);
    }

}