package utopp.gui.pflichtenheft;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import utopp.gui.*;
import utopp.modell.*;

public class PflichtenheftDataPanel extends DataPanel
{
	
	Dialog4Box ZBS;
	Dialog3Box PE;
	Dialog4Box PU;
	Dialog1Box PL;
	DialogComboBox QZ;
	Dialog1Box TS;
	Dialog4Box EU;
	Dialog1Box EG;
	
	JTabbedPane jtpPflichtenheft;
	
    JButton jbApply;

	public PflichtenheftDataPanel() 
    {  
	   super();        
       initGUI();
    }
	

	public PflichtenheftDataPanel(Pflichtenheft ph) 
    {          
       initGUI();
	   setData(ph);
    }
	

  public void setData(Object data){  
  	Pflichtenheft ph = (Pflichtenheft) data;
	
	ZBS.jtatext1.setText(ph.getBeschreibung());
	ZBS.jtatext2.setText(ph.getMusskriterien());
	ZBS.jtatext3.setText(ph.getWunschkriterien());
	ZBS.jtatext4.setText(ph.getAbgrenzungskriterien());
	PE.jtatext1.setText(ph.getAnwendungsbereiche());
	PE.jtatext2.setText(ph.getZielgruppen());
	PE.jtatext3.setText(ph.getBetriebsbedingungen());
	PU.jtatext1.setText(ph.getSoftware1());
	PU.jtatext2.setText(ph.getHardware1());
	PU.jtatext3.setText(ph.getOrgware1());
	PU.jtatext4.setText(ph.getSchnittstellen1());
	PL.jtatext1.setText(ph.getProduktleistungen());
	QZ.jcb1.setSelectedItem(ph.getFunktionalitaet());
	QZ.jcb2.setSelectedItem(ph.getZuverlaessigkeit());
	QZ.jcb3.setSelectedItem(ph.getBenutzbarkeit());
	QZ.jcb4.setSelectedItem(ph.getEffizienz());
	QZ.jcb5.setSelectedItem(ph.getAenderbarkeit());
	TS.jtatext1.setText(ph.getTestszenarien());
	EU.jtatext1.setText(ph.getSoftware2());
	EU.jtatext2.setText(ph.getHardware2());
	EU.jtatext3.setText(ph.getOrgware2());
	EU.jtatext4.setText(ph.getSchnittstellen2());
	EG.jtatext1.setText(ph.getErgaenzungen());
    showing = data;
  };
  
  public void getData(Pflichtenheft item){
  
		item.setBeschreibung(ZBS.jtatext1.getText());
		item.setMusskriterien(ZBS.jtatext2.getText());
		item.setWunschkriterien(ZBS.jtatext3.getText());
		item.setAbgrenzungskriterien(ZBS.jtatext4.getText());
		item.setAnwendungsbereiche(PE.jtatext1.getText());
		item.setZielgruppen(PE.jtatext2.getText());
		item.setBetriebsbedingungen(PE.jtatext3.getText());
		item.setSoftware1(PU.jtatext1.getText());
		item.setHardware1(PU.jtatext2.getText());
		item.setOrgware1(PU.jtatext3.getText());
		item.setSchnittstellen1(PU.jtatext4.getText());
		item.setProduktleistungen(PL.jtatext1.getText());
		item.setFunktionalitaet(QZ.jcb1.getSelectedItem().toString());
		item.setZuverlaessigkeit(QZ.jcb2.getSelectedItem().toString());
		item.setBenutzbarkeit(QZ.jcb3.getSelectedItem().toString());
		item.setEffizienz(QZ.jcb4.getSelectedItem().toString());
		item.setAenderbarkeit(QZ.jcb5.getSelectedItem().toString());
		item.setTestszenarien(TS.jtatext1.getText());
		item.setSoftware2(EU.jtatext1.getText());
		item.setHardware2(EU.jtatext2.getText());
		item.setOrgware2(EU.jtatext3.getText());
		item.setSchnittstellen2(EU.jtatext4.getText());
		item.setErgaenzungen(EG.jtatext1.getText());
  };
  
  public void getData(Object item){
    this.getData((Pflichtenheft) item);
  }
  
  public Object getObject(){
  	Pflichtenheft ph = new Pflichtenheft();
	getData(ph);
	return ph;
  };
  
  public Object getDummy(){
  	return new Pflichtenheft();
  };	
	 
	public void initGUI() 
    {
          GridBagConstraints myGBC = new GridBagConstraints();
          myGBC.fill = GridBagConstraints.BOTH;
		  
          add(jbApply = ComponentFactory.getJButton("Apply", this),myGBC,0,1,1,1,100,0);
		  
          jtpPflichtenheft = new JTabbedPane(JTabbedPane.TOP);
		
          add(jtpPflichtenheft,myGBC,0,0,1,1,100,100);
		  
          jtpPflichtenheft.addTab("Zielbestimmungen",ZBS = new Dialog4Box("Beschreibung", "Mukriterien", "Wunschkriterien", "Abgrenzungskriterien"));
          jtpPflichtenheft.addTab("Produkteinsatz", PE=new Dialog3Box("Anwendungsbereiche", "Zielgruppen", "Betriebsbedingungen"));
          jtpPflichtenheft.addTab("Produktumgebung", PU = new Dialog4Box("Software", "Hardware", "Orgware", "Schnittstellen"));
          jtpPflichtenheft.addTab("Produktleistungen", PL = new Dialog1Box("Produktleistungen")) ;
		  jtpPflichtenheft.addTab("Qualittsziele", QZ = new DialogComboBox());
          jtpPflichtenheft.addTab("Testszenarien",TS = new Dialog1Box("Testszenarien"));
          jtpPflichtenheft.addTab("Entwicklungsumgebung", EU = new Dialog4Box("Software", "Hardware", "Orgware", "Schnittstellen"));
          jtpPflichtenheft.addTab("Ergnzungen", EG = new Dialog1Box("Ergnzungen"));
    }
}

	
	