package utopp.modell;

import java.io.*;
import java.text.*;

import utopp.xml.*;


public class UmlAssRolle extends UmlObject
{
	private UmlKlasse ukKlasse;
	private String sKardinalitaet;

	
	public UmlAssRolle(UmlKlasse klasse, String name, String kardinalitaet){
	  super(name);
	  ukKlasse = klasse;
	  sKardinalitaet = kardinalitaet;
	}
	
	public UmlAssRolle(){
	  this(null, "","");
	}
	
	public UmlKlasse getKlasse () 
	{
		return ukKlasse;
	}

	public String getKardinalitaet () 
	{
		return sKardinalitaet;
	}

	public void setKlasse (UmlKlasse value) 
	{
		ukKlasse = value;
	}

	public void setKardinalitaet (String value) 
	{
		sKardinalitaet = value;
	}
	
	
	// berschrieben!!!
	public String toString(){
	 return (ukKlasse!=null)?getName()+": "+ukKlasse.getName()+" ("+sKardinalitaet+")":getName()+": <klasse> ("+sKardinalitaet+")";
	  	
	}
	
	public void xmlWrite (XmlWriter o, int depth)  throws IOException
	{
	  o.writeTagLn("Rolle", depth);
	  o.writeTaggedValueLn("Klasse",(ukKlasse!=null)?ukKlasse.toString():"<klasse>", depth+1);
	  o.writeTaggedValueLn("Name",getName(),depth+1);
	  o.writeTaggedValueLn("Kardinalitaet",sKardinalitaet,depth+1);
	  o.writeEndTagLn("Rolle", depth);	
	  
	};
	
	public void xmlRead (XmlReader i) throws IOException
	{
	  try{
	  while (i.ready())	
	  {
		ParseResult pr=i.getNext();
		int typ = pr.getState();
		String tag = pr.getTag();
		
		if (typ==3 && tag.equals("Rolle"))
		  break;
		if (typ == 2)  
		{
		    if (tag.equals("Klasse"))
			{
			  // noch was zu tun!
		      i.getTagValue(tag);
			}  
		    else  
		    if (tag.equals("Name"))
		      setName(i.getTagValue(tag));
		    else  
		    if (tag.equals("Kardinalitaet"))
		      sKardinalitaet = i.getTagValue(tag);
		}  
		
	  } // while
	  
	  }
	  catch(ParseException pe){System.out.println(pe);};
	};		

}
