package utopp.modell;

import java.io.*;
import java.text.*;

import utopp.xml.*;

public class UmlAttribut extends UmlObject
{
	private String sTyp;
	private String sSichtbarkeit;
	private String sInitialwert;
	private String sZusicherung;
	private String sEigenschaften;
	private String sAbhaengigkeit;
	
	public UmlAttribut(String typ, String name, String sichtbarkeit, String initialwert, String zusicherung, String eigenschaften, String abhaengigkeit)
	{
		super(name);
		sTyp = typ;
		sSichtbarkeit = sichtbarkeit;
		sInitialwert= initialwert;
		sZusicherung = zusicherung;
		sEigenschaften = eigenschaften;
		sAbhaengigkeit	 = abhaengigkeit;
	}
	
	public UmlAttribut(){
	  this("","","","","","","");
	}
			
	public String getTyp()
	{
		return sTyp;
	}
		
	public String getSichtbarkeit()
	{
		return sSichtbarkeit;
	}
	
	public String getInitialwert()
	{
		return sInitialwert;
	}
	
	public String getZusicherung()
	{
		return sZusicherung;
	}
	
	public String getEigenschaften()
	{
		return sEigenschaften;
	}
	
	public String getAbhaengigkeit()
	{
		return sAbhaengigkeit;
	}
	
	public void setTyp(String value)
	{
		sTyp = value;
	}
	
	public void setSichtbarkeit(String value)
	{
		sSichtbarkeit = value;
	}
	
	public void setInitialwert(String value)
	{
		sInitialwert = value;
	}
	
	public void setZusicherung(String value)
	{
		sZusicherung = value;
	}
	
	public void setEigenschaften(String value)
	{
		sEigenschaften = value;
	}
	
	public void setAbhaengigkeit(String value)
	{
		sAbhaengigkeit = value;
	}
	
	public String toString(){
	  String h = sSichtbarkeit+" "+sTyp+" "+getName();
	  return (sInitialwert==null || sInitialwert.equals(""))?h:h+"="+sInitialwert;	
	
	}
	
		public void xmlWrite (XmlWriter o, int depth)  throws IOException
	{	 	  	
	  o.writeTagLn("Attribut",depth);
	  o.writeTaggedValueLn("Sichtbarkeit",sSichtbarkeit,depth+1);
	  o.writeTaggedValueLn("Typ",sTyp,depth+1);
	  o.writeTaggedValueLn("Name",getName(),depth+1);	  
	  o.writeTaggedValueLn("Initialwert",sInitialwert,depth+1);
	  o.writeTaggedValueLn("Zusicherung",sZusicherung,depth+1);
	  o.writeTaggedValueLn("Eigenschaften",sEigenschaften,depth+1);
	  o.writeTaggedValueLn("Abhaegigkeit",sAbhaengigkeit,depth+1);
	  o.writeEndTagLn("Attribut",depth);
	  
	};
	
	public void xmlRead (XmlReader i) throws IOException
	{
	  
	  try{
	  while (i.ready())	
	  {
		ParseResult pr=i.getNext();
		int typ = pr.getState();
		String tag = pr.getTag();
		
		if (typ==3 && tag.equals("Attribut"))
		  break;
		if (typ == 2)  
		{
		    if (tag.equals("Sichtbarkeit"))
		      sSichtbarkeit = i.getTagValue(tag);
		    else 		
		    if (tag.equals("Typ"))
		      sTyp = i.getTagValue(tag);
		    else  
		    if (tag.equals("Name"))
		      setName(i.getTagValue(tag));
		    else  
		    if (tag.equals("Initialwert"))
		      sInitialwert = i.getTagValue(tag);
			else 
		    if (tag.equals("Zusicherung"))
		      sZusicherung = i.getTagValue(tag);
		    else  
		    if (tag.equals("Eigenschaften"))
		      sEigenschaften = i.getTagValue(tag);
		    else 
		    if (tag.equals("Abhaengigkeit"))
		      sAbhaengigkeit = i.getTagValue(tag);
		}  
		
	  } // while
	  
	  }
	  catch(ParseException pe){System.out.println(pe);};
		//
	};
	
}
	