package utopp.modell;

import java.util.*;
import java.io.*;
import java.text.*;

import utopp.xml.*;

public class UmlMethode extends UmlObject
{
	private String sRueckgabetyp;
	private String sSichtbarkeit;
	private String sZusicherung;
	private String sEigenschaften;
	
	private UmlParameterListe plParameter;
	
	public UmlMethode(){
	  super("");
	  plParameter = new UmlParameterListe();
	
	}
	
	public UmlMethode(String name, String rueckgabetyp, String sichtbarkeit,
		String zusicherung, String eigenschaften)
	{
		super(name);
		sRueckgabetyp = rueckgabetyp;
		sSichtbarkeit = sichtbarkeit;
		sZusicherung = zusicherung;
		sEigenschaften = eigenschaften;
	    plParameter = new UmlParameterListe();
	}
	
	public String getRueckgabetyp () 
	{
		return sRueckgabetyp;
	}

	public String getSichtbarkeit () 
	{
		return sSichtbarkeit;
	}

	public String getZusicherung () 
	{
		return sZusicherung;
	}

	public String getEigenschaften () 
	{
		return sEigenschaften;
	}

	public void setRueckgabetyp (String value) 
	{
		sRueckgabetyp = value;
	}

	public void setSichtbarkeit (String value) 
	{
		sSichtbarkeit = value;
	}

	public void setZusicherung (String value) 
	{
		sZusicherung = value;
	}

	public void setEigenschaften (String value) 
	{
		sEigenschaften = value;
	}
	
	public UmlParameterListe getParameter(){
	  return plParameter;
	}
	
	public void setParameter(UmlParameterListe param)
	{		
	  plParameter = param;
	}
	
    	/**
	 *
	 *
	 * @return String, so wie er im Fenster angezeigt wird     
	 */
	public String toString()
	{
		return sSichtbarkeit+" "+sRueckgabetyp+" "+getName()+"("+plParameter+")";
	}		
	
	public boolean equals(Object obj){
	  return (obj!=null)?obj.toString().equals(toString()):false;
	}
	
	public void xmlWrite (XmlWriter o, int depth)  throws IOException
	{	  	
	  o.writeTagLn("Methode", depth);
	  o.writeTaggedValueLn("Sichtbarkeit",sSichtbarkeit,depth+1);
	  o.writeTaggedValueLn("Rueckgabetyp",sRueckgabetyp,depth+1);
	  o.writeTaggedValueLn("Name",getName(),depth+1);
	  o.writeTaggedValueLn("Zusicherung",sZusicherung,depth+1);
	  o.writeTaggedValueLn("Eigenschaften",sEigenschaften,depth+1);
	  plParameter.xmlWrite(o,depth+1);	  
	  o.writeEndTagLn("Methode", depth);	  
	};
	
	public void xmlRead (XmlReader i) throws IOException
	{
	  
	  try{
	  while (i.ready())	
	  {
		ParseResult pr=i.getNext();
		int typ = pr.getState();
		String tag = pr.getTag();
		
		if (typ==3 && tag.equals("Methode"))
		  break;
		if (typ == 2)  
		{
		    if (tag.equals("Sichtbarkeit"))
		      sSichtbarkeit = i.getTagValue(tag);
		    else 		
		    if (tag.equals("Rueckgabetyp"))
		      sRueckgabetyp = i.getTagValue(tag);
		    else  
		    if (tag.equals("Name"))
		      setName(i.getTagValue(tag));
		    else 			 
		    if (tag.equals("Zusicherung"))
		      sZusicherung = i.getTagValue(tag);
		    else 
		    if (tag.equals("Eigenschaften"))
		      sEigenschaften = i.getTagValue(tag);
			else if (tag.equals("Parameterliste"))
			  plParameter.xmlRead(i);  
		}  
		
	  } // while
	  
	  }
	  catch(ParseException pe){System.out.println(pe);};
		//
		//
	};		
	
}

