package utopp.modell;

import java.io.*;
import java.text.*;

import utopp.xml.*;

public class UmlParameter extends UmlObject
{
	private String sTyp;
	private String sInitialwert;
		

	/**
	 * vollstndiger Konstruktor fr diese Objekt
	 * 
	 *
	 * @param   typ  Datentyp des Parameters
	 * @param   name eindeutiger Name des Parameters fr die Methode 
	 * @param   initialwert Standardwert fr den Parameter, falls dieser ausgelassen wird 
	 */
	public UmlParameter(String typ, String name, String initialwert){
	  super(name);
	  sTyp = typ;
	  sInitialwert = initialwert;
	
	}
	
	public UmlParameter(){
	  this("","","");
	}
	
    public Object clone(){
	  return new UmlParameter(sTyp,getName(),sInitialwert);
	}
	
	/**
	 *
	 *
	 * @return Typ    
	 */
	public String getTyp () 
	{
		return sTyp;
	}


	/**
	 *
	 *
	 * @return Initialwert    
	 */
	public String getInitialwert () 
	{
		return sInitialwert;
	}


	/**
	 *
	 *
	 * @param   value  
	 */
	public void setTyp (String value) 
	{
		sTyp = value;
	}


	/**
	 *
	 *
	 * @param   value  
	 */
	public void setInitialwert (String value) 
	{
		sInitialwert = value;
	}
	

	/**
	 *
	 *
	 * @return String, so wie er im Fenster angezeigt wird     
	 */
	public String toString()
	{   String h = sTyp+" "+getName();
		return (sInitialwert==null || sInitialwert.equals(""))?h:h+"("+sInitialwert+")";
	}
	
	public void xmlWrite (XmlWriter o, int depth)  throws IOException
	{	  	
	  o.writeTagLn("Parameter",depth);
	  o.writeTaggedValueLn("Typ",sTyp,depth+1);
	  o.writeTaggedValueLn("Name",getName(),depth+1);
	  o.writeTaggedValueLn("Initialwert",sInitialwert,depth+1);
	  o.writeEndTagLn("Parameter",depth);
	  
	};
	
	public void xmlRead (XmlReader i) throws IOException
	{
	  try{
	  while (i.ready())	
	  {
		ParseResult pr=i.getNext();
		int typ = pr.getState();
		String tag = pr.getTag();
		
		if (typ==3 && tag.equals("Parameter"))
		  break;
		if (typ == 2)  
		{
		    if (tag.equals("Typ"))
		      sTyp = i.getTagValue(tag);
		    else  
		    if (tag.equals("Name"))
		      setName(i.getTagValue(tag));
		    else  
		    if (tag.equals("Initialwert"))
		      sInitialwert = i.getTagValue(tag);
		}  
		
	  } // while
	  
	  }
	  catch(ParseException pe){System.out.println(pe);};
	};		

}

