package utopp.modell;

import java.io.*;
import java.util.*;
import java.text.*;

import utopp.xml.*;
import utopp.diagram.*;

public class UmlProjekt extends UmlObject
{
	
	private Pflichtenheft phPflichtenheft;
	
	private UmlKlassenListe uklKlassenliste;
	
	private UmlAssoziationsListe ualAssoziationsliste;
	
	private UmlUseCaseListe uclUseCaseliste;

        private DiagramCollection diagramme;
	
	
    public UmlProjekt(String name, Pflichtenheft ph, UmlKlassenListe ukl, UmlAssoziationsListe ual, UmlUseCaseListe uucl)
    {
	  super(name);
      phPflichtenheft=ph;
	  uklKlassenliste = ukl;
	  ualAssoziationsliste = ual;
      uclUseCaseliste=uucl;
      diagramme=new DiagramCollection();
    }          

    public UmlProjekt()
    {
      super("leer");
	  phPflichtenheft = new Pflichtenheft();
	  uklKlassenliste = new UmlKlassenListe();
	  ualAssoziationsliste = new UmlAssoziationsListe();
      uclUseCaseliste= new UmlUseCaseListe();
      diagramme= new DiagramCollection();
	  
    }
	
	public UmlKlassenListe getKlassenliste () 
	{
		return uklKlassenliste;
	}

	public void setKlassenliste (UmlKlassenListe value) 
	{
	 	uklKlassenliste = value;
	}
		
	public UmlAssoziationsListe getAssoziationsliste () 
	{
		return ualAssoziationsliste;
	}

	public void setAssoziationsliste (UmlAssoziationsListe value) 
	{
	 	ualAssoziationsliste = value;
	}	
	
	public UmlUseCaseListe getUseCaseliste () 
	{
		return uclUseCaseliste;
	}

	public void setUseCaseliste (UmlUseCaseListe value) 
	{
	 	uclUseCaseliste = value;
	}		

	
	public Pflichtenheft getPflichtenheft()
	{
	return this.phPflichtenheft;
	}

	public void setPflichtenheft(Pflichtenheft value)
	{
	this.phPflichtenheft = value;
	}
		
        public DiagramCollection getDiagramCollection()
          {
          return this.diagramme;
          }

        public void setDiagramCollection(DiagramCollection d)
          {
          this.diagramme=d;
          }

	public void xmlWrite (XmlWriter o, int depth) throws IOException
	{
	  o.writeTagLn("Utopp", depth);
	  o.writeTagLn("Projekt",depth+1);
	  o.writeTaggedValueLn("Name",getName(),depth+2);
	  phPflichtenheft.xmlWrite(o,depth+2);
	  uklKlassenliste.xmlWrite(o,depth+2);
      ualAssoziationsliste.xmlWrite(o,depth+2);
	  uclUseCaseliste.xmlWrite(o,depth+2);
	  o.writeEndTagLn("Projekt",depth+1);
	  o.writeEndTagLn("Utopp", depth);
	};
	
	public void xmlRead (XmlReader i) throws IOException
	{
	  
	  int state = 32; 
	  try{
	  while (state<34 && i.ready())	
	  {
		ParseResult pr=i.getNext();
		int typ = pr.getState();
		String tag = pr.getTag();
		
		if (typ==2)
		{
			if (tag.equals("Projekt") && typ==2 && state ==32)
			  state = 33;
			else
			if (state==33) 
			{
			if (tag.equals("Name"))
   			  setName(i.getTagValue(tag));
			else 
			if (tag.equals("Pflichtenheft"))
			  phPflichtenheft.xmlRead(i);
			else 
			if (tag.equals("Klassenliste"))
  		      uklKlassenliste.xmlRead(i);
			else				
			if (tag.equals("Assoziationsliste"))				        
  			  ualAssoziationsliste.xmlRead(i);
			else
			if (tag.equals("UseCaseliste"))						
  			  uclUseCaseliste.xmlRead(i);
			}    				 
		}else
		if (typ==3 && tag.equals("Projekt") && state ==33)
		  state = 34;			
		
	  } // while
	  
	  }
	  catch(ParseException pe){System.out.println(pe);};

	  
	};



}