// by H.B
//NEU: 04.01.01 implementation Viewable zum Testen

package utopp.modell;

import java.io.*;
import java.text.*;

import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;

import utopp.xml.*;
import utopp.diagram.*;

public class UmlUseCase extends UmlObject implements Viewable
  {
  private String sNummer;
  private String sAkteure;
  private String sVorbedingungen;
  private String sNachbedingungen;
  private String sInvarianten;
  private String sNichtFunktAnfor;
  private String sAblauf;
  private String sVariationen;
  private String sRegeln;
  private String sServices;
  private String sAnmerkungen;
  private String sAnsprechpartner;
  
  final private int thisWidth=200;
  final private int thisHeight=50;
  
  //Konstruktor1
  public UmlUseCase(String[][] data)
    {
	super("");
    setData(data);
    }

  //Konstruktor2
  public UmlUseCase(String name)
    {
    super(name);
	
    sNummer="";
    sAkteure="";
    sVorbedingungen="";
    sNachbedingungen="";
    sInvarianten="";
    sNichtFunktAnfor="";
    sAblauf="";
    sVariationen="";
    sRegeln="";
    sServices="";
    sAnmerkungen="";
    sAnsprechpartner="";
    }

  //Konstruktor3 
  public UmlUseCase()
  {
  	this("");
  }

  public String[][] getData()
    {
    String[][] thisData = new String[4][];
    String[] mainTab = new String[4];
    mainTab[0]=getName();
    mainTab[1]=sAkteure;
    mainTab[2]=sVorbedingungen;
    mainTab[3]=sNachbedingungen;
    thisData[0]=mainTab;
    String[] ablaufTab = new String[1];
    ablaufTab[0]=sAblauf;
    thisData[1]=ablaufTab;
    String[] misc1Tab = new String[4];
    misc1Tab[0]=sInvarianten;
    misc1Tab[1]=sNichtFunktAnfor;
    misc1Tab[2]=sVariationen;
    misc1Tab[3]=sRegeln;
    thisData[2]=misc1Tab;
    String[] misc2Tab = new String[3];
    misc2Tab[0]=sServices;
    misc2Tab[1]=sAnmerkungen;
    misc2Tab[2]=sAnsprechpartner;
    thisData[3]=misc2Tab;
    return thisData;
    }

  public void setData(String[][] data)
    {
    setName(data[0][0]);
    sAkteure=data[0][1];
    sVorbedingungen=data[0][2];
    sNachbedingungen=data[0][3];
     //Daten vom AblaufTab
    sAblauf=data[1][0];
     //Daten vom Misc 1 Tab
    sInvarianten=data[2][0];
    sNichtFunktAnfor=data[2][1];
    sVariationen=data[2][2];
    sRegeln=data[2][3];
     //Daten vom Misc 2 Tab
    sServices=data[3][0];
    sAnmerkungen=data[3][1];
    sAnsprechpartner=data[3][2];
    }//end setData()

  public String getNummer() 
    {
    return sNummer;
    }

  public String getAkteure() 
    {
    return sAkteure;
    }

  public String getVorbedingungen() 	
    {
    return sVorbedingungen;
    }

  public String getNachbedingungen() 
    {
    return sNachbedingungen;
    }

  public String getInvarianten() 
    {
    return sInvarianten;
    }

  public String getNichtFunktAnfor() 
    {
    return sNichtFunktAnfor;
    }

  public String getAblauf() 
    {
    return sAblauf;
    }

  public String getVariationen() 
    {
    return sVariationen;
    }

  public String getRegeln() 
    {
    return sRegeln;
    }

  public String getServices() 
    { 
    return sServices;
    }

  public String getAnmerkungen() 
    {
    return sAnmerkungen;
    }

  public String getAnsprechpartner() 
    {
    return sAnsprechpartner;
    }

  public void setNummer(String value) 
    {
    sNummer = value; 
    }

  public void setAkteure(String value) 
    {
    sAkteure = value; 
    }

  public void setVorbedingungen(String value) 
    {
    sVorbedingungen = value;
    }

  public void setNachbedingungen(String value) 
    {
    sNachbedingungen = value;
    }

  public void setInvarianten(String value) 
    {
    sInvarianten = value;
    }

  public void setNichtFunktAnfor(String value) 
    {
    sNichtFunktAnfor = value;
    }

  public void setAblauf(String value) 
    {
    sAblauf = value;
    }

  public void setVariationen(String value) 
    {
    sVariationen = value;
    }

  public void setRegeln(String value) 
    {
    sRegeln = value;
    }

  public void setServices(String value) 
    {
    sServices = value;
    }

  public void setAnmerkungen(String value) 
    {
    sAnmerkungen = value;
    }

  public void setAnsprechpartner(String value) 
    {
    sAnsprechpartner = value;
    }

  public String toStringComplete()
    {
    return "\nMain:\n\nNummer:\n"+sNummer+"\n\nName:\n"+getName()+"\n\nAkteur:\n"+sAkteure
            +"\n\nVorbedingung:\n"+sVorbedingungen
            +"\n\nNachbedingungen:\n"+sNachbedingungen
            +"\n\nAblauf:\n"+sAblauf
            +"\n\nSonstiges 1:"
            +"\n\nInvarianten:\n"+sInvarianten
            +"\n\nNichtfunktionale Anforderungen:\n"+sNichtFunktAnfor
	    +"\n\nVariationen:\n"+sVariationen	
            +"\n\nRegeln:\n"+sRegeln
            +"\n\nSonstiges 2:"
            +"\n\nServices:\n"+sServices
            +"\n\nAnmerkungen:\n"+sAnmerkungen
            +"\n\nAnsprechpartner:\n"+sAnsprechpartner;
     }
     
     
  public void xmlWrite (XmlWriter o, int depth) throws IOException
  {
	  o.writeTagLn("UseCase", depth);
	  o.writeTaggedValueLn("Nummer",sNummer,depth+1);
	  o.writeTaggedValueLn("Name",getName(),depth+1);
	  o.writeTaggedValueLn("Akteure",sAkteure,depth+1);
	  o.writeTaggedValueLn("Vorbedingungen",sVorbedingungen,depth+1);
	  o.writeTaggedValueLn("Nachbedingungen",sNachbedingungen,depth+1);
	  o.writeTaggedValueLn("Invarianten",sInvarianten,depth+1);
	  o.writeTaggedValueLn("NichtFunktAnfor",sNichtFunktAnfor,depth+1);
	  o.writeTaggedValueLn("Ablauf",sAblauf,depth+1);
	  o.writeTaggedValueLn("Variationen",sVariationen,depth+1);
	  o.writeTaggedValueLn("Regeln",sRegeln,depth+1);
	  o.writeTaggedValueLn("Services",sServices,depth+1);
	  o.writeTaggedValueLn("Anmerkungen",sAnmerkungen,depth+1);
	  o.writeTaggedValueLn("Ansprechpartner",sAnsprechpartner,depth+1);
	  o.writeEndTagLn("UseCase", depth);
  }
	
  public void xmlRead (XmlReader i) throws IOException
  {
	  try{
	  while (i.ready())	
	  {
		ParseResult pr=i.getNext();
		int typ = pr.getState();
		String tag = pr.getTag();
		
		if (typ==3 && tag.equals("UseCase"))
		  break;
		if (typ == 2)  
		{
		    if (tag.equals("Nummer"))
		      sNummer = i.getTagValue(tag);
		    else  
		    if (tag.equals("Name"))
		      setName(i.getTagValue(tag));
		    else  
		    if (tag.equals("Akteure"))
		      sAkteure = i.getTagValue(tag);
		    else  
		    if (tag.equals("Vorbedingungen"))
		      sVorbedingungen = i.getTagValue(tag);
		    else  
		    if (tag.equals("Nachbedingungen"))
		      sNachbedingungen = i.getTagValue(tag);
		    else  
		    if (tag.equals("Invarianten"))
		      sInvarianten = i.getTagValue(tag);
			else			
			if (tag.equals("NichtFunktAnfor"))
			  sNichtFunktAnfor = i.getTagValue(tag);
		    else
			if (tag.equals("Ablauf"))
			  sAblauf = i.getTagValue(tag);
		    else
			if (tag.equals("Variationen"))
			  sVariationen = i.getTagValue(tag);
		    else
			if (tag.equals("Regeln"))
			  sRegeln = i.getTagValue(tag);
		    else
			if (tag.equals("Services"))
			  sServices = i.getTagValue(tag);
		    else
			if (tag.equals("Anmerkungen"))
			  sAnmerkungen = i.getTagValue(tag);
		    else
			if (tag.equals("Ansprechpartner"))
			  sAnsprechpartner = i.getTagValue(tag);
		}	
		
	  } // while
	  
	  }
	  catch(ParseException pe){System.out.println(pe);};
  }
     
  public BufferedImage getImage()
    {
    //TEST
    BufferedImage buff = new BufferedImage(thisWidth,thisHeight,BufferedImage.TYPE_INT_ARGB);
    createPicture(buff.createGraphics());
    return buff;
    }

  public DiagramObject getDiagramObject()
    {
    //TEST
    return new DiagramObject(getImage(),this.getName(),"UmlUseCase");
    }

  public void createPicture(Graphics2D g)
    {
    //TEST
    Ellipse2D.Double ell = new Ellipse2D.Double(0,0,thisWidth-1,thisHeight-1);
    g.setColor(Color.white);
    g.fill(ell);
    g.setColor(Color.black);
    g.draw(ell);
    Font f = new Font("SansSerif", Font.BOLD, 14);
    FontMetrics fm = g.getFontMetrics(f);
    int stringWidth = fm.stringWidth(getName());
    int stringHeight = fm.getHeight();
    int stringXPos = (thisWidth - stringWidth)/2;
    int stringYPos = 30;
    g.setFont(f);
    g.drawString(this.getName(),stringXPos,stringYPos);
    }

}//end class UmlUseCase
