package utopp.xml;

import java.io.*;
import java.text.*;

public class XmlReader extends InputStreamReader{
    
  public XmlReader(InputStream is){
  	super(is);
	buf = new StringBuffer();
  }
  
  private StringBuffer buf;
   
  private char getNextChar() throws IOException, ParseException{
  	int i;
  	if ((i = read())==-1)
	  throw new ParseException("Unexpected end of stream" +buf,0);
	else
      return (char) i;
  } 
  
  public ParseResult getNext() throws IOException, ParseException{
      
	int state = 0;
	StringBuffer tag = new StringBuffer();
	char c;
	for (;;)
	{
	  c = getNextChar();
	  switch (c)
	  {
	  	case '<':{
	      if (state>1)
		    throw new ParseException("Tag begins in tag",0);
	  	  if (state==0) 
		  { 
		    c = getNextChar();
			if (c=='/')
			  state = 3;
			else  
			{
				state = 2;
				tag.append(c);
			}
		  }
		  else buf.append(c);	
		} break;
		case '>':{
		  if (state>1)
		  	return new ParseResult(tag.toString(), state);
		  else buf.append(c); //throw new ParseException("Unexpected character",0);
		} break;
		case '/':{
		  if (state>2)
		  	throw new ParseException("Unexpected character in Tag",0);
		  if (state==2)
		  {	
		    char r = getNextChar();	
		    if (r=='>') 
		      return new ParseResult(tag.toString(), 4);
			else throw new ParseException("Unexpected character",0);
		  }
		  else buf.append(c);
		  		  
		} break;
		default:{
		  if (state>1)
		  	tag.append(c);
		  else
		    buf.append(c);
		}			
	  }
		  
		  
	}
  }
  
  public String getTagValue(String tag) throws IOException, ParseException{
  	buf=new StringBuffer();
	ParseResult pr;
	for (;;)
	{
		pr = getNext();
		if (pr.getState()==3 && tag.equals(pr.getTag()))
		  break;
		else
		  buf.append(XmlFactory.getTag(pr.getTag()));  
	}
	return buf.toString();
  };
  
  public String getBuffer(){
  	return buf.toString();
  }
}